"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCustomValidation = void 0;
const lodash_1 = require("lodash");
const ajvMap = { number: "imum", string: "Length", array: "Items", object: "Properties" };
const getMinMaxValidation = (keyword, type, value) => (0, lodash_1.set)({}, keyword + ajvMap[typeMap[type]], +value);
const typeMap = {
    array: "string",
    date: "string",
    number: "number",
    string: "string",
    ref: "object",
    object: "object",
};
function getCustomValidation(decorator, type) {
    const decoratorName = (0, lodash_1.camelCase)(decorator.getName());
    const decoratorParams = decorator.getArguments();
    switch (decoratorName) {
        case "time":
        case "date":
        case "dateTime":
        case "duration":
        case "uri":
        case "uriReference":
        case "uriTemplate":
        case "email":
        case "hostname":
        case "ipv4":
        case "ipv6":
        case "uuid":
        case "jsonPointer":
        case "relativeJsonPointer":
            return { format: (0, lodash_1.snakeCase)(decoratorName) };
        case "pattern":
            return { pattern: decorator.getArguments()[0] };
        case "numberString":
            return { pattern: "^[0-9]*$" };
        case "min":
        case "max":
            return getMinMaxValidation(decoratorName, type, decoratorParams[0].getText());
        case "schema":
            return JSON.parse(decoratorParams[0].getText().replace(/(['"])?([a-z0-9A-Z_]+)(['"])?:/g, '"$2": '));
    }
    return {};
}
exports.getCustomValidation = getCustomValidation;
