"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.omitDeepBy = void 0;
const lodash_1 = require("lodash");
function omitDeepBy(input, by) {
    function omitDeepOnOwnProps(obj) {
        if (typeof input === "undefined") {
            return input;
        }
        if (!Array.isArray(obj) && !isObject(obj)) {
            return obj;
        }
        if (Array.isArray(obj)) {
            return omitDeepBy(obj, by);
        }
        const o = {};
        for (const [key, value] of Object.entries(obj)) {
            o[key] = !isNil(value) ? omitDeepBy(value, by) : value;
        }
        return (0, lodash_1.omitBy)(o, by);
    }
    if (Array.isArray(input)) {
        return input.map(omitDeepOnOwnProps);
    }
    return omitDeepOnOwnProps(input);
}
exports.omitDeepBy = omitDeepBy;
function isNil(value) {
    return value === null || value === undefined;
}
function isObject(obj) {
    return Object.prototype.toString.call(obj) === "[object Object]";
}
